<?php

namespace RxConnexionBundle\Controller;

use RxConnexionBundle\Entity\AccountUserTypeEntity;
use RxConnexionBundle\Entity\NoteTemplateEntity;
use RxConnexionBundle\Form\NoteTemplateForm;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\JsonResponse;

use RxConnexionBundle\Entity\AuditTrailEntity;

/**
 * @Route("/main/note_template")
 */
class NoteTemplateController extends Controller
{
    /**
     * @Route("", name="note_template")
     */
    public function indexAction() {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Note Template'))) return $authService->redirectToHome();

        return $this->render('@RxConnexion/NoteTemplate/index.html.twig', array(
            'title' => 'Manage Note Template',
            'page_title' => 'Manage Note Template',
            'javascripts' => array('rxconnexion/admin/js/noteTemplate/noteTemplate.js?v=1.0.1')
        ));
    }

    /**
     * @Route("/ajax_list", name="note_template_ajax_list")
     */
    public function ajax_list(Request $request) {

        $get = $request->query->all();

        $result = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => 0,
            "recordsFiltered" => 0,
            "data" => array()
        );

        $authService = $this->get('rx_connexion.authService');
        if($authService->isLoggedIn()) {

            $hasUpdate = $authService->isUserHasAccesses(array('Admin Note Template Update'), false);

            $data = $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:NoteTemplateEntity')->ajax_list($get, $this->get('session')->get('userData'));

            foreach($data['results'] as $row) {

                $id = base64_encode($row['id']);
                $action = '';

                if($hasUpdate) {
                    $url = $this->generateUrl('note_template_form', array(
                        'action' => 'u',
                        'id' => $id
                    ));
                    $action = "<a class='action-button-style' href='$url'>Update</a>";
                }

                $values = array(
                    $row['description'],
//                    $row['noteType_description'],
                    $action
                );

                $result['data'][] = $values;
            }

            $result['recordsTotal'] = $data['total'];
            $result['recordsFiltered'] = $data['total'];
        }

        return new JsonResponse($result);
    }

    /**
     * @Route(
     *      "/form/{action}/{id}",
     *      defaults = {
     *          "action":  "n",
     *          "id": 0
     *      },
     *      requirements = {
     *          "action": "n|u"
     *      },
     *      name = "note_template_form"
     * )
     */
    public function formAction($action, $id, Request $request) {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Note Template New', 'Admin Note Template Update'))) return $authService->redirectToHome();

        $em = $this->getDoctrine()->getManager();

        $noteTemplate = $em->getRepository('RxConnexionBundle:NoteTemplateEntity')->find(base64_decode($id));
        if(!$noteTemplate) {
            $noteTemplate = new NoteTemplateEntity();
        }

        $formOptions = array('action' => $action);
        $form = $this->createForm(NoteTemplateForm::class, $noteTemplate, $formOptions);

        if($request->getMethod() === 'POST') {

            $device_form = $request->get($form->getName());
            $result = $this->processForm($device_form, $noteTemplate, $form, $request);

            if($result['success']) {
                if($result['redirect'] === 'index') {
                    return $this->redirect($this->generateUrl('note_template'), 302);
                } else if($result['redirect'] === 'form') {
                    return $this->redirect($this->generateUrl('note_template_form', array(
                        'action' => 'u',
                        'id' => base64_encode($result['id'])
                    )), 302);
                } else if($result['redirect'] === 'form with error') {
                    return $this->redirect($this->generateUrl('note_template_form'), 302);
                }
            } else {
                $form->submit($device_form, false);
            }
        }

        $userTypes = $em->getRepository(AccountUserTypeEntity::class)->findBy(array(
            'isDeleted' => false
        ));

        $title = ($action === 'n' ? 'New' : 'Update') . ' Note Template';

        return $this->render('@RxConnexion/NoteTemplate/form.html.twig', array(
            'title' => $title,
            'page_title' => $title,
            'javascripts' => array('rxconnexion/admin/js/noteTemplate/noteTemplate_form.js?v=1.0.0'),
            'form' => $form->createView(),
            'action' => $action,
            'userTypes' => $userTypes,
            'id' => $id
        ));
    }

    private function processForm($note_template_form, $note_template, $form, Request $request) {

        $em = $this->getDoctrine()->getManager();

        $errors = $em->getRepository('RxConnexionBundle:NoteTemplateEntity')->validate($note_template_form);

        if(!count($errors)) {

            switch($note_template_form['action']) {

                case 'n': // new

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $noteForm = $request->get('noteForm');

                        $note_template->setUserType($noteForm['userType']);
                        $em->persist($note_template);
                        $em->flush();

                        $newAT = new AuditTrailEntity(
                            'Note Template',
                            $em->getClassMetadata(NoteTemplateEntity::class)->getTableName(),
                            AuditTrailEntity::AXN_NEW
                        );
                        $newAT->entity = $note_template;
                        $newAT->parseDetails();
                        $em->persist($newAT);
                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Saved.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'u': // update

                    $newAT = new AuditTrailEntity(
                        'Device',
                        $em->getClassMetadata(NoteTemplateEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_UPDATE
                    );
                    $newAT->entity = $note_template;
                    $newAT->parseOriginalDetails();

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $newAT->parseDetails();
                        $em->persist($newAT);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Updated.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'd': // delete

                    $newAT = new AuditTrailEntity(
                        'Note Template',
                        $em->getClassMetadata(NoteTemplateEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_DELETE
                    );
                    $newAT->entity = $note_template;
                    $newAT->parseDetails();
                    $em->persist($newAT);

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        //$em->remove($device);
                        $note_template->setIsDeleted(true);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Deleted.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;
            }

            $result['success'] = true;

        } else {

            foreach($errors as $error) {
                $this->get('session')->getFlashBag()->add('error_messages', $error);
            }

            $result['success'] = false;
        }

        return $result;
    }

    /**
     * @Route("/autocomplete", name="note_template_autocomplete")
     */
    public function autocompleteAction(Request $request) {

        $q = $request->get('query');
        $userData = $this->get('session')->get('userData');
        $result = array(
            'query' => 'countries',
            'suggestions' => $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:NoteTemplateEntity')->autocomplete_suggestions($q, $userData)
        );

        return new JsonResponse($result);
    }

    /**
     * @Route(
     *      "/note_template_data/{description}",
     *      defaults = {
     *          "description": null,
     *      },
     *      name = "note_template_data"
     * )
     */
    public function noteTemplateData(Request $request, $description) {

        $em = $this->getDoctrine()->getManager();
        $noteTemplateData = $em->getRepository('RxConnexionBundle:NoteTemplateEntity')->findOneBy(array(
           'description' => urldecode($description),
           'isDeleted' => 0,
        ));
        $noteTemplateDataArray = array();
        if ($noteTemplateData && $noteTemplateData != null) {
            $noteTemplateDataArray = array(
                'note' => $noteTemplateData->getNote()
            );
        } else {
            $noteTemplateDataArray = array(
                'note' => '',
            );
        }


        return new JsonResponse($noteTemplateDataArray);
    }
}
